import React, { useState, useEffect } from 'react';
import { json } from 'd3';
import { feature, mesh } from 'topojson';

const jsonUrl = 'https://cdn.jsdelivr.net/npm/us-atlas@3/states-10m.json';

export const southStates = () => {
  const [data, setData] = useState(null);
  
    useEffect(() => {
      json(jsonUrl).then(topology => {
        const { states } = topology.objects;
        for (let i =0; i< states.geometries.length; ++i)
        {
          switch (states.geometries[i].properties.name)
          {
            case 'Deleware':
            case 'Maryland':
            case 'West Virginia':
            case 'Virginia':
            case 'Kentucky':
            case 'Tennessee':
            case 'North Carolina':
            case 'South Carolina':
            case 'Georgia':
            case 'Florida':
            case 'Alabama':
            case 'Mississippi':
            case 'Arkansas':
            case 'Louisiana':
            case 'Oklahoma':
            case 'Texas':
              break;
            default: 
              states.geometries[i] = 'null';
              break;
          }
        }
        setData({
          state: feature(topology, states),
          interiors: mesh(topology, states, (a, b) => a !== b)
       });
     });
   }, []);
 
  return data;
};
