import React, { useState, useEffect } from 'react';
import { json } from 'd3';
import { feature, mesh } from 'topojson';

const jsonUrl = 'https://cdn.jsdelivr.net/npm/us-atlas@3/states-10m.json';

export const useUSMap = () => {
  const [data, setData] = useState(null);
  
    useEffect(() => {
      json(jsonUrl).then(topology => {
        const { states } = topology.objects;
	
        console.dir(states.geometries[0]);
        for (let i =0; i< states.geometries.length; ++i)
        {
          
          switch (states.geometries[i].properties.name)
          {
            case 'Alaska':
            case 'Hawaii':
            case 'Puerto Rico':
            case 'United States Virgin Islands':
            case 'Commonwealth of the Northern Mariana Islands':
            case 'Guam':
            case 'American Samoa':
              states.geometries[i] = 'null';
              break;
            default: 
              break;
          }
        }
        
        setData({
          state: feature(topology, states),
          interiors: mesh(topology, states, (a, b) => a !== b)
       });
     });
   }, []);
 
  return data;
};
