import React, { useState, useEffect } from 'react';
import { json } from 'd3';
import { feature, mesh } from 'topojson';

const jsonUrl = 'https://cdn.jsdelivr.net/npm/us-atlas@3/states-10m.json';

export const westStates = () => {
  const [data, setData] = useState(null);
  
    useEffect(() => {
      json(jsonUrl).then(topology => {
        const { states } = topology.objects;
        for (let i =0; i< states.geometries.length; ++i)
        {
          switch (states.geometries[i].properties.name)
          {
            case 'Alaska':
            case 'Hawaii':
            case 'Washington':
            case 'Oregon':
            case 'California':
            case 'Nevada':
            case 'Arizona':
            case 'New Mexico':
            case 'Colorado':
            case 'Utah':
            case 'Wyoming':
            case 'Montana':
            case 'Idaho':
              break;
            default: 
              states.geometries[i] = 'null';
              break;
          }
        }
        //states.geometries[1] = "null";
        //console.dir(states.geometries[1].properties.name);
        setData({
          state: feature(topology, states),
          interiors: mesh(topology, states, (a, b) => a !== b)
       });
     });
   }, []);
 
  return data;
};
